//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "final_prog.h"

#include <stdio.h>
#include "usb.h"
#include "libusb_dyn.c"
#include <math.h>
 #include "fft.h"
#include "fft.cpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma link "CCALENDR"
#pragma resource "*.dfm"
TForm1 *Form1;

#define READ_VERSION            0
#define COLLECT_OSC_DATA        1
#define READ_OSC_DATA           2
#define SET_OFFSET              3
#define SET_TIMESCALE           4
#define SET_SYNC                5
/* the device's vendor and product id */
#define MY_VID 0x04d8
#define MY_PID 0x0002

/* the device's endpoints */
#define EP_IN  0x81
#define EP_OUT 0x01

#define BUF_SIZE 64
  unsigned char pkt[64], data[256];
  struct usb_bus         *bus;
  struct usb_device      *udev;
  struct usb_dev_handle  *dev;
  int            i,j,k=0, ind;
  int            x,y;
  float          v,vmax, vmin, vamp, t = 0;
  int            timescale;
  int            offset;
  int            sync;
  char ps[128], sn[128], buffer[256];
  int ret;
  int trig, f;
  float       b,tr,Period,n1,n2;
  double fdisc;
  int fl1 = 0;
  ShortComplex sp[256];
  unsigned char z[256];
  float  w = 1.0;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
Form1->DoubleBuffered = true;
Form1->Panel1->DoubleBuffered = true;
Form1->Panel7->Color = clLime;
Form1->Panel8->Color = clMedGray;
Form1->Panel9->Color = clBlack;
Form1->Panel10->Color  = clWhite;
Form1->Width = 983;
Form1->time->Position = 2;
Form1->M->Clear();
Form1->M->Lines->Add("ISC OSCILLOSCOPE VID:0x04d8; PID:0x0002");
Form1->TrackBar1->Position = 250;
Form1->Label42->Caption = FloatToStrF(tr/10,AnsiString::sffFixed,1,2);
 ind = 0;
 Form1->Label40->Caption = "";
 Form1->M->Height = 293;


}
//---------------------------------------------------------------------------
double round(double number)
{
    return number < 0.0 ? ceil(number - 0.5) : floor(number + 0.5);
}
void setOffset( int v )
{
    offset = 15 - v;
    pkt[0] = SET_OFFSET;
    pkt[1] = offset;
    if( dev ) usb_bulk_write(dev, USB_ENDPOINT_OUT | 1, (char *)&pkt, 2, 1000);
}

void setSync( int v )
{
    sync = v/10;
    pkt[0] = SET_SYNC;
    pkt[1] = round((sync + 50) * 2.56);
    if( dev ) usb_bulk_write(dev, USB_ENDPOINT_OUT | 1, (char *)&pkt, 2, 1000);
    Form1->Image1->Repaint();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
if( dev )                                 //
    {                                       //
	usb_release_interface( dev, 0 );    //
	usb_close( dev );                   //
    }

//dev = 0;
  usb_init();
  usb_find_busses(); /* find all busses */
  usb_find_devices(); /* find all connected devices */

  for(bus = usb_get_busses(); bus; bus = bus->next)
    {
      for(udev = bus->devices; udev; udev = udev->next)
        {
          //M->Lines->Add(123);
          if(udev->descriptor.idVendor == MY_VID
             && udev->descriptor.idProduct == MY_PID)
            {
              dev = usb_open(udev);
              Form1->M->Lines->Add("device found!!!");
              usb_set_configuration(dev,1);
              usb_claim_interface(dev, 0);

              if(!dev)
              {
                  Form1->M->Lines->Add("device open failed");
                  goto nod;
              }

              if (usb_set_configuration(dev, 1)<0)
              {
                  Form1->M->Lines->Add("not claimed");
                  goto nod;
              }

              if (usb_claim_interface(dev,0)<0)
              {
                  Form1->M->Lines->Add("not claimed");
                  goto nod;
              }
              usb_get_string_simple(dev, 2, ps, sizeof(ps));
              usb_get_string_simple(dev, 3, sn, sizeof(sn));
              goto yes;
            }

        }
    }
nod:
   if( dev )
   {

      usb_close( dev );
      dev = NULL;

   }   Form1->M->Lines->Add("device not found");
   return;

yes:
   setOffset(8);
   time->Position = 2;
   setSync(0);

   Form1->Button3->Visible = true;
   Form1->Button4->Visible = true;
   Form1->Button5->Visible = true;
   Form1->GroupBox2->Visible = true;

   Form1->Timer1->Interval = 50;
   Form1->Timer1->Enabled = true;

}

//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
  for ( i = 0; i<64; i++)
  {
     pkt[0] = 1;
     pkt[1] = i;
     usb_bulk_write(dev, EP_OUT,(char *)&pkt, 1, 1000);
     usb_bulk_read(dev, EP_IN, (char *)&pkt, 1, 1000);
  }


  for ( i = 0; i<4; i++)
  {
     pkt[0] = 2;
     pkt[1] = i;
     usb_bulk_write(dev, EP_OUT,(char *)&pkt, 2, 1000);
     usb_bulk_read(dev, EP_IN, (char *)&pkt, 64, 1000);
      for( j = 0; j<64; j++, x++)
      {
          data[x] = pkt[j];
          Form1->M->Lines->Add(data[j]);
      }
  } Form1->Label14->Caption = k++;
  x = 0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer2Timer(TObject *Sender)
{
       float Fr1 = 0;
       PatBlt(Form1->Image1->Canvas->Handle,      //
                0,                                //
                0,                                //
                Form1->Image1->Width,             //      
                Form1->Image1->Height,            //
                Form1->Panel9->Color                         //
                );                                //
     Form1->Image1->Canvas->Pen->Width = 1;
     Form1->Image1->Canvas->Pen->Color = Form1->Panel8->Color;      //  
     for (i = 0; i<11; i++)                               //
     {                                                    //
         y = 5 + i*Image1->Height/10;                     //    (=)
         Image1->Canvas->MoveTo(0,y);                     //
         Image1->Canvas->LineTo(Image1->Width,y);         //

     }
     for (i = 0; i<11; i++)                               //
     {                                                    //
         x = 5 + i*Image1->Width/10;                      //    (||)
         Image1->Canvas->MoveTo(x,0);                     //
         Image1->Canvas->LineTo(x,Image1->Height);        //
     }
         //zero level/////////////////
         Form1->Image1->Canvas->Pen->Width = 4;
         //Form1->Image1->Canvas->Pen->Color = Form1->Panel10->Color;
         y = 5 + 5*Image1->Height/10;
         Image1->Canvas->MoveTo(0,y);
         Image1->Canvas->LineTo(Image1->Width,y);
         //Form1->Image1->Canvas->Pen->Width = 4;
         ///////////////////////.....
     //Form1->Image1->Canvas->Pen->Width = 4;
     Form1->Image1->Canvas->Pen->Color = Form1->Panel7->Color;     //  

     Form1->Image1->Canvas->MoveTo(0,Form1->TrackBar1->Position);
     x = 0;


     for (int x = 0; x<256; x++)
     {
        y = Form1->TrackBar1->Position - data[x];
        Form1->Image1->Canvas->LineTo(x*3, y);
        v = data[i] - 128;
        if( v > vmax ) vmax = v;
        if( v < vmin ) vmin = v;
     }
              //---------------cursors---------
        Form1->Image1->Canvas->Pen->Width = 2;
        Form1->Image1->Canvas->Pen->Color = clRed;     //

        Form1->Image1->Canvas->MoveTo(Form1->ScrollBar1->Position,0);
        Form1->Image1->Canvas->LineTo(Form1->ScrollBar1->Position,Image1->Height);

        Form1->Image1->Canvas->MoveTo(Form1->ScrollBar2->Position,0);
        Form1->Image1->Canvas->LineTo(Form1->ScrollBar2->Position,Image1->Height);
        //period and freq between cursors
         n1 = Form1->ScrollBar1->Position;
        n2 = Form1->ScrollBar2->Position;
        Period = abs(n1-n2)*t;
        Fr1 = 1000000/(Period+0.0001);
         if (Fr1 >= 1000)
        {
        Fr1 = Fr1/1000;
        Form1->Label5->Caption = "";

        }else{

         if(Fr1 >= 1000000)
         {
         Fr1 = Fr1/1000000;
         Label5->Caption = "";
         }
         else  {Label5->Caption = "";};
         }
        Form1->Label4->Caption = FloatToStrF(Fr1,AnsiString::sffFixed,6,3);
       
        if (Period > 1000)             //ms
        {
        Period = Period/1000;
        Form1->Label30->Caption = "";

        }
        else             //us
        {
        Label30->Caption = "";
         }
        Form1->Label25->Caption = FloatToStrF(Period,AnsiString::sffFixed,6,3);
        //zero-crossing rate:

        
        //Voltages
      vmax = vmax / 25.6 ;
      Form1->Label18->Caption = FloatToStrF(vmax,AnsiString::sffFixed,1,2);
      vmin = vmin / 25.6 ;
      Form1->Labe10->Caption = FloatToStrF(vmin,AnsiString::sffFixed,1,2);
      vamp = vmax-vmin;
      Form1->Label12->Caption = FloatToStrF(vamp,AnsiString::sffFixed,1,2);
      

}
//---------------------------------------------------------------------------


void __fastcall TForm1::timeChange(TObject *Sender)
{
  int timescale = time->Position-2;                               //
                                                                //
      switch(timescale)                                         //
    {                                                           //
      case  0: {Form1->Label17->Caption = "5 /";                  //
      t = 0.066; fdisc = 5120000;}   break;   //                                     //
      case  1: {Form1->Label17->Caption = "10 /";                 //
      t = 0.132; fdisc = 2560000;}  break;   //                                     //
      case  2: {Form1->Label17->Caption = "20 /";                 //
      t = 0.264; fdisc = 1280000;}  break;   //                                     //
      case  3: {Form1->Label17->Caption = "50 /";                 //
      t = 0.658; fdisc = 512000;}  break;   //                                     //
      case  4: {Form1->Label17->Caption = "0.1 /";                 //
      t = 1.316; fdisc = 256000;}  break;   //                                    //
      case  5: {Form1->Label17->Caption = "0.2 /";                 //
      t = 2.632; fdisc = 128000;}  break;   //                                    //
      case  6: {Form1->Label17->Caption = "0.5 /";                 //
      t = 6.579; fdisc = 51200;}  break;   //                                    //
      case  7: {Form1->Label17->Caption = "1 /";                   //
      t = 13.158; fdisc = 25600;}    break;   //                                 //
      case  8: {Form1->Label17->Caption = "2 /";                   //
      t = 26.316; fdisc = 15500;}    break;   // ...                                //
      case  9: {Form1->Label17->Caption = "5 /";                   //
      t = 65.789; fdisc = 15500;}    break;   //  ...                               //
      case 10: {Form1->Label17->Caption = "10 /";                  //
      t = 131.579; fdisc = 15500;}   break;   //    ...                             //
      case 11: {Form1->Label17->Caption = "20 /";                  //
      t = 263.158; fdisc = 15500;}  break;   //     ...                             //
    }                                                           //
    pkt[0] = SET_TIMESCALE;                                     //
    pkt[1] = timescale;                                         //
    if( dev )                                                   //
    usb_bulk_write(dev, EP_OUT,(char *)&pkt, 2, 1000);          //                                     //
    Form1->Image1->Repaint();                                   //
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------

  ///exit program
void __fastcall TForm1::Button2Click(TObject *Sender)
{
//usb_close( dev );
//    dev = NULL;
     Form1->Close();
    

}

//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
      Form1->Timer1->Enabled = false;
        //Form1->Timesp->Enabled = false;
      //Form1->Timer2->Enabled = false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
      Form1->Timer1->Enabled = true;
      //Form1->Timer2->Enabled = true;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button5Click(TObject *Sender)
{     SavePictureDialog1->FileName = "oscg";
      SavePictureDialog1->DefaultExt = "bmp";
      if(SavePictureDialog1->Execute())
      {
      Image1->Canvas->TextOutA(Image1->Width-70,Image1->Height-15,Form1->Label17->Caption);

      Image1->Canvas->TextOutA(Image1->Width-150,Image1->Height-15,"Umax:");
      Image1->Canvas->TextOutA(Image1->Width-120,Image1->Height-15,FloatToStrF(vmax,AnsiString::sffFixed,1,2));

      Image1->Canvas->TextOutA(Image1->Width-235,Image1->Height-15,"Umin:");
      Image1->Canvas->TextOutA(Image1->Width-208,Image1->Height-15,FloatToStrF(vmin,AnsiString::sffFixed,1,2));

      Image1->Canvas->TextOutA(Image1->Width-310,Image1->Height-15,"Uamp:");
      Image1->Canvas->TextOutA(Image1->Width-280,Image1->Height-15,FloatToStrF(vamp,AnsiString::sffFixed,1,2));

      Form1->Image1->Picture->SaveToFile(SavePictureDialog1->FileName);
}      }
//---------------------------------------------------------------------------

void __fastcall TForm1::TriggerChange(TObject *Sender)
{
     tr = Form1->Trigger->Position;
      setSync(tr/10);
      Form1->Label42->Caption = FloatToStrF(tr/10,AnsiString::sffFixed,1,2);
}
//---------------------spectrum analyzer mode on----------------------------


//---------------------------------------------------------------------------



//-------------------back to oscope mode----------------------------------------


//---------------------------------------------------------------------------


void __fastcall TForm1::Button6Click(TObject *Sender)
{
        Form1->Button7->Font->Color = clBlack;
        Form1->Button6->Font->Color = clRed;

        Form1->Button3->Visible = false;
        Form1->Button4->Visible = false;
        Form1->SPpause->Visible = true;
        Form1->SPgo->Visible = true;

        Form1->Timer2->Enabled = false;     //off oscilloscope timer
        Form1->Image1->Visible = false;      //off oscilloscope background
        Form1->Timesp->Interval = 50;       // 50ms current timer
        Form1->Timesp->Enabled = true;      //on this timer
        Form1->Spectrum->Visible = true;    //on spectrum backgroung
        Form1->GroupBox5->Visible = true;   //on spectrum info box
        Form1->M->Height = 112;

}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void __fastcall TForm1::TimespTimer(TObject *Sender)
{

    int i;  //index of complex sp[] array

    //freq of dicre
    double nSamplesPerSec = fdisc;
    Form1->Label19->Caption = nSamplesPerSec;

    //middle of array
    int Nmax= (255 + 1) / 2;

    //arrays of...
    double freq[128];
    double amp[128];
    double phase[128];

    // harmonica index
    int j= 0;

    //harmonica ampl limit
    double limit= 0.001;

    // optimization var
    double abs2min= limit * limit * 256 * 256;

    //--------put data to complex data array >> fft---------
        for(i = 0; i<256; i++)
        {
        sp[i].re = data[i]*w;
        
        sp[i].im = 0.0;
        }
        fft(sp, 8, false);
    //-------finding constant part of signal------


         if (sp[i].re >= limit)
        {

                amp[j]= sp[i].re / 256;
		freq[j]= 0.0;
		phase[j]= 0.0;

        }
         ++i;

      //-------find others harmonics ------
      for(i= 1; i < Nmax; ++i)
    {
        double re= sp[i].re;
        double im= sp[i].im;

        // sqr of modul
        double abs2= re * re + im * im;


        //low harmonics no
        if (abs2 < abs2min)
            continue;

         //ampl (without mirror effect)
        amp[j]= 2.0 * sqrt(abs2) / 256;

        //phase of COS
        phase[j]= atan2(im, re);

        //COS >> SIN
        phase[j]+= 1.571;
        if (phase[j] > 3.142)
        phase[j]-= 6.283;

        //get freq
        freq[j]= (nSamplesPerSec * i) / 256;
       ++j;
    }
      Form1->Label13->Caption = j;

  //===================================================================
        //---drawing spectrum-----


        int x = 1;
        Series1->Clear();

      switch(fl1){
 case 0: {
          for (int x = 0; x<127; x++)
          {
          Series1->AddXY(freq[x],amp[x],clBlue);
          }
          break;
          };

  case 1: {
          for (int x = 0; x<127; x++)
          {
          Series1->AddXY(freq[x],phase[x],clBlue);
          }
          break;
          };
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button7Click(TObject *Sender)
{
        Form1->Button7->Font->Color = clRed;
        Form1->Button6->Font->Color = clBlack;

        Form1->Button3->Visible = true;
        Form1->Button4->Visible = true;
        Form1->SPpause->Visible = false;
        Form1->SPgo->Visible = false;

        Form1->Timer2->Enabled = true;     //off oscilloscope timer
        Form1->Image1->Visible = true;      //off oscilloscope background
        Form1->Timesp->Enabled = false;      //on this timer
        Form1->Spectrum->Visible = false;    //on spectrum backgroung
        Form1->GroupBox5->Visible = false;   //on spectrum info box
         Form1->M->Height = 293;
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------

//---------------------------------------------------------------------------

//---------------------------------------------------------------------------

void __fastcall TForm1::N1Click(TObject *Sender)
{
   Form1->Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N2Click(TObject *Sender)
{     SavePictureDialog1->FileName = "oscg";
      SavePictureDialog1->DefaultExt = "bmp";
      if(SavePictureDialog1->Execute())
      {
      Image1->Canvas->TextOutA(Image1->Width-70,Image1->Height-15,Form1->Label17->Caption);

      Image1->Canvas->TextOutA(Image1->Width-150,Image1->Height-15,"Umax:");
      Image1->Canvas->TextOutA(Image1->Width-120,Image1->Height-15,FloatToStrF(vmax,AnsiString::sffFixed,1,2));

      Image1->Canvas->TextOutA(Image1->Width-205,Image1->Height-15,"Umin:");
      Image1->Canvas->TextOutA(Image1->Width-178,Image1->Height-15,FloatToStrF(vmin,AnsiString::sffFixed,1,2));

      Image1->Canvas->TextOutA(Image1->Width-260,Image1->Height-15,"Uamp:");
      Image1->Canvas->TextOutA(Image1->Width-230,Image1->Height-15,FloatToStrF(vamp,AnsiString::sffFixed,1,2));

      Form1->Image1->Picture->SaveToFile(SavePictureDialog1->FileName);
}         
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N6Click(TObject *Sender)
{
 Form1->Button7Click(Sender);

}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------


//---------------------------------------------------------------------------


void __fastcall TForm1::N3Click(TObject *Sender)
{
Form1->Width = 983;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N18Click(TObject *Sender)
{
Form1->Width = 767;
}
//--------------save adc data---------------------------------------------------

void __fastcall TForm1::N5Click(TObject *Sender)
{

   
 AnsiString day, month, year, hour, min, sec;
 day   = FormatDateTime("dd", Now());
 month = FormatDateTime("mm", Now());
 year  = FormatDateTime("yyyy", Now());
 hour  = FormatDateTime("hh", Now());
 min   = FormatDateTime("mm", Now());
 sec   = FormatDateTime("ss", Now());
 Form1->M->Lines->SaveToFile("ADCData-"+day+"-"+month+"-"+year+"-"+hour+"-"+min+"-"+sec+".txt");
 ShowMessage("     \n ADCData-"+day+"-"+month+"-"+year+"-"+hour+"-"+min+"-"+sec+".txt   ");

}
//---------------------------------------------------------------------------


void __fastcall TForm1::N4Click(TObject *Sender)
{
  if(Form1->ColorDialog1->Execute()) {
   Form1->Panel7->Color = ColorDialog1->Color;    //grafik
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N19Click(TObject *Sender)
{
   if(Form1->ColorDialog1->Execute()) {
   Form1->Panel8->Color = ColorDialog1->Color;      //sitka
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N20Click(TObject *Sender)
{
    if(Form1->ColorDialog1->Execute()) {
   Form1->Panel9->Color = ColorDialog1->Color;              //fon
  }
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------

void __fastcall TForm1::N22Click(TObject *Sender)
{
 Form1->Button6Click(Sender);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::N15Click(TObject *Sender)
{
 fl1 = 0; //ampl-freq spectrum
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N16Click(TObject *Sender)
{
 fl1 = 1; //phase-freq spectrum
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N13Click(TObject *Sender)
{
////linear mode
 Form1->Spectrum->LeftAxis->Logarithmic = false;
 Form1->Label39->Caption = "˳";
 
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N14Click(TObject *Sender)
{
////log mode
 Form1->Spectrum->LeftAxis->Logarithmic = true;
 Form1->Label39->Caption = "";
}
//---------------------------------------------------------------------------


void __fastcall TForm1::N11Click(TObject *Sender)
{
Form1->Label40->Caption = "";
w = 1.0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N12Click(TObject *Sender)
{
Form1->Label40->Caption = "SIN-";
w = sin(0.012319971*i);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N28Click(TObject *Sender)
{
Form1->Label40->Caption = "-";
w = 0.62-0.48*abs((i/255)-0.5)-0.38*cos(0.027925268*i);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N29Click(TObject *Sender)
{
Form1->Label40->Caption = "";
w = 0.54-0.46*cos(0.027925268*i);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N25Click(TObject *Sender)
{
Form1->Label40->Caption = "";
w = 0.42-0.50*cos(0.027925268*i)+0.08*cos(0.055850536*i);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N26Click(TObject *Sender)
{
Form1->Label40->Caption = "";
w = 0.355768-0.487396*cos(0.027925268*i)+0.144232*cos(0.055850536*i)+0.012604*cos(0.083775804*i);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N27Click(TObject *Sender)
{
Form1->Label40->Caption = "-";
w = 0.3625819-0.4891775*cos(0.027925268*i)+0.1365995*cos(0.055850536*i)+0.0106411*cos(0.083775804*i);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::N931Click(TObject *Sender)
{
Form1->Label40->Caption = " (-69 )";
w = exp((-0.5)*((i-127.5)/(38.25))*((i-127.5)/(38.25)));
}
//-----------------color mode1---------------------------------------------------

void __fastcall TForm1::N110Click(TObject *Sender)
{

   Form1->Panel7->Color = clLime;              //grafik

//---------------------------------------------------------------------------

   Form1->Panel8->Color = clMedGray;                //sitka

//---------------------------------------------------------------------------

   Form1->Panel9->Color = clBlack;         //fon

//---------------------------------------------------------------------------

}
//------------------color mode2----------------------------------------------------

void __fastcall TForm1::N210Click(TObject *Sender)
{
   Form1->Panel7->Color = clBlue;              //grafik

//---------------------------------------------------------------------------

   Form1->Panel8->Color = clMedGray;                //sitka

//---------------------------------------------------------------------------

   Form1->Panel9->Color = clWhite;         //fon
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N17Click(TObject *Sender)
{
 SavePictureDialog1->FileName = "spectrum";
      SavePictureDialog1->DefaultExt = "bmp";
      if(SavePictureDialog1->Execute())
      {
      Form1->Spectrum->SaveToBitmapFile(SavePictureDialog1->FileName);
      }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SPpauseClick(TObject *Sender)
{
Form1->Timesp->Enabled = false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SPgoClick(TObject *Sender)
{
Form1->Timesp->Enabled = true;
}
//---------------------------------------------------------------------------

